using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;
using AxCopyController02;
using CopyController02;
using Microsoft.VisualBasic.CompilerServices;

//****************************************** HELP
//RCK1.P_ProgramID (e.g. "4AD14721F3698705BA618E2C" )
//   * Activation Key encryption logic will depend on this key
//   * ProgramID Must have 24 Characters
//   * All Characters of ProgramID Must be 0 To 9 OR 'A' To 'F'
//
//RCK1.P_Sequence (e.g. "ABCDEFGHIJKLMNOPQRSTUVWXYZ" this is default value)
//   * for advance protection use this property otherwise not require
//   * Sequence String length Must be 26 characters
//   * All characters must be between ('A' to 'Z') OR (0 to 9)
//   * No character must repeat
//   * Here output character Key(Activation Code Or MID Code) is map as "A as A,B as B,
//       C as C....as on Z as Z". you can change maping value as per your requirement
//   * E.g.
//          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
//          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQ123456789"
//          RCK1.P_Sequence = "ZYXWVUTSRQPONMLKJIHGFEDCBA"
//
//RCK1.P_SoftwareID (e.g. 1 is Default value)
//   *   If you have more than 1 software use this property(if you changed P_ProgramID in
//       all your softwares then you don't set this property)
//   * SoftwareID Must Be Between 1 To 26
//   * E.g.
//           RCK1.P_SoftwareID = 1 (For School Software)
//           RCK1.P_SoftwareID = 2 (For Account Software)
//           RCK1.P_SoftwareID = 3 (For Payslip)
//
//############### NOTE ################
//IN DEMO VERSION
//YOU CAN NOT CHANGE VALUE OF FOLLOWING PROPERTY. VALUE OF FOLLOWING PROPERTY IS READONLY IN DEMO VERSION
//   RCK1.P_ProgramID = "0123456789ABCDEF01234567"
//   RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
//   RCK1.P_SoftwareID = 1
//#####################################
//******************************************
namespace KeyGenApp
{
	public partial class FrmKeyGen
	{
		public FrmKeyGen()
		{
			InitializeComponent();
			if (defaultInstance == null)
				defaultInstance = this;
		}
		
#region Default Instance
		private static FrmKeyGen defaultInstance;
		public static FrmKeyGen Default
		{
			get
			{
				if (defaultInstance == null)
				{
					defaultInstance = new FrmKeyGen();
					defaultInstance.FormClosed += new FormClosedEventHandler(defaultInstance_FormClosed);
				}
				
				return defaultInstance;
			}
		}
		
		static void defaultInstance_FormClosed(object sender, FormClosedEventArgs e)
		{
			defaultInstance = null;
		}
		
#endregion
		public void cmdExit_Click(System.Object sender, System.EventArgs e)
		{
			ProjectData.EndApp();
		}
		
		public void FrmKeyGen_Load(System.Object sender, System.EventArgs e)
		{
			RCK1.P_ProgramID = "0123456789ABCDEF01234567"; // Activation Key encryption logic will depend on this key
			RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; // enter Sequence charactors. output character Key(Activation Code Or MID Code) is map as "A as A,B as B,C as C....as on Z as Z" but you can change this sequence by this parameter (e.g. ABCDEFGHIJKLMNOPQ123456789 )
			RCK1.P_SoftwareID = 1; // 1 For School Software, 2 For Account Software, 3 For Payslip ...As on
			
			//*** return Miscellaneous Serial No which you can use here or any other perpose
			string HDDModule1 = "";
            //IDE_DRIVE_NUMBER HardDrive = IDE_DRIVE_NUMBER.PRIMARY_MASTER;  
            short HardDrive = 0;

			TxtMacAddress.Text = (string) RCK1.M_GetMacAddress();
			TxtBaseboardNo.Text = (string) RCK1.M_GetMotherBoardSerialNo();
            TxtHDD.Text = (string)(RCK1.M_GetHDDDSerialNo(ref HardDrive ,ref HDDModule1));  
			TxtModule.Text = HDDModule1;
			TxtProcess.Text = RCK1.M_GetProcessorId();
			//***
		}
		
		public void CmdUnprotectMID_Click(System.Object sender, System.EventArgs e)
		{
			string UniqueNo="";
			BASEBORD_HDD_PROC_MAC_LABEL UniqueType =BASEBORD_HDD_PROC_MAC_LABEL.E_NONE;
			short SoftwareID =0;
			int ErrorNo=0;
			
			ErrorNo = System.Convert.ToInt32(RCK1.M_UnProtectMID1(TxtMID.Text ,ref UniqueNo, ref UniqueType ,ref SoftwareID));
			//Parameters description
			//TxtMID.Text-> Pass MID code (which you have received from your client)
			//UniqueID	-> Return Unique ID
			//UniqueType	-> Return Unique ID type.1 For Motherboard Sr.No., 2 For HardDisk Sr.no.,
			//			   3 For Processor Sr.no., 4 For MAC Address.
			//SoftwareID	-> Return software ID
			//Function return 0 For MID Code unprotect Successfully
			if (ErrorNo != 0)
			{
				switch (ErrorNo)
				{
					case -1:
						Interaction.MsgBox("width of MID Code must be 17 characters",MsgBoxStyle.OkOnly , "");
						break;
					case -2:
                        Interaction.MsgBox("Every Character of MID Code must be between \'A\' to \'Z\'", MsgBoxStyle.OkOnly, "My App");
						break;
						//OR As per your RCK1.SequenceNo no
						//(if RCK1.SequenceNo = 'ABCDEFGHIJKLMNOP0123456789' then 'A' to 'P' OR 0 TO 9 )
					case -3:
						MessageBox.Show("Invalid MID Code(Typing mistake) or this MID Code is not for this application");
						break;
				}
			}
			if (ErrorNo == 0)
			{
				switch (SoftwareID)
				{
					case 1:
						LblSoftwareName.Text = "School Software";
						break;
					case 2:
						LblSoftwareName.Text = "Account Software";
						break;
					case 3:
						LblSoftwareName.Text = "Payslip Software";
						break;
				}
				TxtSoftwareID.Text = SoftwareID.ToString();
				if (Option1.Checked == true)
				{
					if (SoftwareID != 1)
					{
						MessageBox.Show("This MID Code is not for School Software");
						return;
					}
				}
				else if (Option2.Checked == true)
				{
					if (SoftwareID != 2)
					{
						MessageBox.Show("This MID Code is not for Accounting Software");
						return;
					}
				}
				else if (Option3.Checked == true)
				{
					if (SoftwareID != 3)
					{
						MessageBox.Show("This MID Code is not for Pay Slip Software");
						return;
					}
				}
				
				switch (UniqueType)
				{
					case BASEBORD_HDD_PROC_MAC_LABEL.E_BASEBORDNO:
						LblUniqueType.Text = "MOTHERBOARD NO";
                        TxtUnqueIDType.Text = "1";
						break;
					case BASEBORD_HDD_PROC_MAC_LABEL.E_HDDSR:
						LblUniqueType.Text = "HDD SERIAL NO";
                        TxtUnqueIDType.Text = "2";
						break;
					case BASEBORD_HDD_PROC_MAC_LABEL.E_PROCESSORID:
						LblUniqueType.Text = "PROCESSOR SERIAL NO";
                        TxtUnqueIDType.Text = "3";
						break;
					case BASEBORD_HDD_PROC_MAC_LABEL.E_MACADDRESS:
						LblUniqueType.Text = "MAC ADDRESS";
                        TxtUnqueIDType.Text = "4";
						break;
					case BASEBORD_HDD_PROC_MAC_LABEL.E_HDDLABEL:
						LblUniqueType.Text = "HDD LABEL";
                        TxtUnqueIDType.Text = "5";
						break;
				}
				TxtUniqureID.Text = UniqueNo;
			}
			if (ErrorNo == 0)
			{
				MessageBox.Show("Success");
			}
		}
		
		public void CmdAct_Click(System.Object sender, System.EventArgs e)
		{
			string Act1;
			Act1 = (string) (RCK1.M_GetAct1(TxtMID.Text.Trim()));
			//Function Return Activation Code or return following error no
			// "-1" for	width of MID Code(parameter) must be 17 characters
			// "-2" for	Every character of MID Code must be "A" TO "Z"
			// "-3" for	Invalid MID Code(Typing mistake) or this MID Code is not for
			//				this application
			//e.g. 'INXY-DUPY-EFER-QYZG'
			//
			TxtAct.Text = Act1;
		}
		
		public void lblTheroyalsoftware_LinkClicked(System.Object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("http://www.theroyalsoftware.com");
		}
		
	}
	
}
